mod Maux

incl Mtex

incl Mtexrc

rem 
  \para \bf  Case discrimination function.  \end 

fun/3 D1 'Tex_f3_rec_d1'
  D1(0,y,z) = z
  D1(x+1,y,z) = y

rem 
  \para \bf  Characteristic functions.  \end 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

fun/2 Nef 'Tex_f2_char_nef'
  Nef(x,y) = 1 <- x != y
  Nef(x,y) = 0 <- x = y

fun/2 Lef 'Tex_f2_char_lef'
  Lef(x,y) = 1 <- x <= y
  Lef(x,y) = 0 <- x > y

fun/2 Ltf 'Tex_f2_char_ltf'
  Ltf(x,y) = 1 <- x < y
  Ltf(x,y) = 0 <- x >= y

fun/2 Gef 'Tex_f2_char_gef'
  Gef(x,y) = 1 <- x >= y
  Gef(x,y) = 0 <- x < y

fun/2 Gtf 'Tex_f2_char_gtf'
  Gtf(x,y) = 1 <- x > y
  Gtf(x,y) = 0 <- x <= y

rem 
  \para \bf  Integer square root.  \end 
  \eq* 
    Sq Tex_f1_n_sqrt(x) <= x & x < Sq(Tex_f1_n_sqrt(x)+1)
  \end

fun Sgn 'Tex_f1_n_sgn'
  Sgn(0) = 0
  Sgn(x) = 1 <- x != 0

fun Sqrt 'Tex_f1_n_sqrt'
  Sqrt(x) = Sgn(z) <- x = 4*y+z & 0 <= z & z <= 3 & y = 0
  Sqrt(x) = r <- 
    x = 4*y+z & 0 <= z & z <= 3 & y != 0 & 2*Sqrt(y) = r & x < Sq(r+1)
  Sqrt(x) = r+1 <- 
    x = 4*y+z & 0 <= z & z <= 3 & y != 0 & 2*Sqrt(y) = r & x >= Sq(r+1)

